> ## Documentation Index
> Fetch the complete documentation index at: https://www.helius.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# getNonInclusionProofs

> ヌリファイアがプライバシーヌリファイアツリーに存在しないことを示す証明を取得します。

## 非包含証明

1～1,000 個のヌリファイア値とヌリファイアツリーアカウントを指定します。各リーフは BN254 スカラー体の要素をエンコードする必要があります。ヌリファイアがそのツリーですでに使用されているか、キューに追加されている場合、リクエストは失敗します。証明は、リクエストされたリーフの順序に従います。

各証明には、兄弟 `path`、境界となる `lowElement` および `highElement` の値とそのインデックス、さらにルートが含まれます。ヌリファイアツリーでは、`rootSeq` はツリーの更新シーケンスであり、`rootIndex` は Solana アカウントのルート履歴におけるルートの位置です。

## リクエストパラメーター

**leaves** `array` *required*

base58 形式の 32 バイト BN254 スカラー体要素としてエンコードされたヌリファイア値です。

**treeAccount** `string` *required*

クエリ対象のツリーアカウントです。ステートツリーとヌリファイアツリーは 1 つのアカウントを共有します。


## OpenAPI

````yaml ja/openapi/privacy/getNonInclusionProofs.yaml POST /v1/spr/getNonInclusionProofs
openapi: 3.0.3
info:
  title: Solana プライバシーリング API
  version: 0.51.2
  description: 暗号化された状態、履歴、証明、公開レジストリレコードのためのプライバシーインデクサー JSON-RPC API です。
servers:
  - url: https://devnet.helius-rpc.com
    description: Devnet Solana プライバシーリング API
security: []
paths:
  /v1/spr/getNonInclusionProofs:
    post:
      summary: getNonInclusionProofs
      description: プライバシーヌリファイアツリーにヌリファイアが存在しないことを示す証明を取得します。
      operationId: getNonInclusionProofs
      requestBody:
        content:
          application/json:
            schema:
              type: object
              required:
                - jsonrpc
                - id
                - method
                - params
              properties:
                id:
                  type: string
                  description: リクエストを識別するための ID です。
                  default: '1'
                jsonrpc:
                  type: string
                  description: JSON-RPC プロトコルのバージョンです。
                  enum:
                    - '2.0'
                  default: '2.0'
                method:
                  type: string
                  description: 呼び出すメソッドです。URL パスの最後のセグメントと一致する必要があります。
                  enum:
                    - getNonInclusionProofs
                  default: getNonInclusionProofs
                params:
                  type: object
                  required:
                    - treeAccount
                    - leaves
                  properties:
                    leaves:
                      type: array
                      items:
                        $ref: '#/components/schemas/Hash'
                      minItems: 1
                      maxItems: 1000
                      description: base58 でエンコードされた 32 バイトの BN254 スカラー体要素として表されるヌリファイア値です。
                    treeAccount:
                      allOf:
                        - $ref: '#/components/schemas/SerializablePubkey'
                      description: クエリ対象のツリーアカウントです。状態ツリーとヌリファイアツリーは 1 つのアカウントを共有します。
                  additionalProperties: false
                  example:
                    treeAccount: 33KVhbT4QtdQDrrrGwwThqD47Dh4Q6tA443t9jMNcWFN
                    leaves:
                      - '11111111111111111111111111111112'
            example:
              jsonrpc: '2.0'
              id: '1'
              method: getNonInclusionProofs
              params:
                treeAccount: 33KVhbT4QtdQDrrrGwwThqD47Dh4Q6tA443t9jMNcWFN
                leaves:
                  - '11111111111111111111111111111112'
        required: true
      responses:
        '200':
          description: JSON-RPC レスポンスです。result を読み取る前に error を確認してください。
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                properties:
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
                  id:
                    type: string
                    description: リクエスト ID です。
                  jsonrpc:
                    type: string
                    description: JSON-RPC プロトコルのバージョンです。
                    enum:
                      - '2.0'
                  result:
                    type: object
                    required:
                      - context
                      - proofs
                    properties:
                      context:
                        $ref: '#/components/schemas/Context'
                      proofs:
                        type: array
                        items:
                          $ref: '#/components/schemas/NonInclusionProof'
                    additionalProperties: false
        '400':
          description: >-
            実行前に拒否されました。メソッドとパスの不一致、メソッドフィールドの重複、またはバッチリクエストの場合は -32601
            が返されます。読み取り不能またはサイズ超過のボディの場合は -32600 が返されます。
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                  - error
                properties:
                  jsonrpc:
                    type: string
                    enum:
                      - '2.0'
                  id:
                    type: string
                    nullable: true
                    description: リクエスト ID です。ボディが単一の JSON-RPC 呼び出しでない場合は null です。
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
        '429':
          description: レート制限を超過しました。
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                  - error
                properties:
                  jsonrpc:
                    type: string
                    enum:
                      - '2.0'
                  id:
                    type: string
                    nullable: true
                    description: リクエスト ID です。ボディが単一の JSON-RPC 呼び出しでない場合は null です。
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
        '500':
          description: 内部サーバーエラーです。
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                  - error
                properties:
                  jsonrpc:
                    type: string
                    enum:
                      - '2.0'
                  id:
                    type: string
                    nullable: true
                    description: リクエスト ID です。ボディが単一の JSON-RPC 呼び出しでない場合は null です。
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
      security:
        - ApiKeyQuery: []
components:
  schemas:
    Hash:
      type: string
      description: base58 でエンコードされた 32 バイトのハッシュです。
    SerializablePubkey:
      type: string
      description: base58 でエンコードされた Solana 公開鍵です。
    Context:
      type: object
      required:
        - blockTime
        - slot
      properties:
        blockTime:
          type: integer
          format: int64
        slot:
          type: integer
          format: uint64
          description: スロットに基づく鮮度チェックに使用する、インデクサーが永続化した最上位のスロットです。
          minimum: 0
    NonInclusionProof:
      type: object
      required:
        - leaf
        - merkleContext
        - path
        - lowElement
        - lowElementIndex
        - highElement
        - highElementIndex
        - root
        - rootSeq
        - rootIndex
      properties:
        highElement:
          $ref: '#/components/schemas/Hash'
        highElementIndex:
          type: integer
          format: uint64
          minimum: 0
        leaf:
          $ref: '#/components/schemas/Hash'
        lowElement:
          $ref: '#/components/schemas/Hash'
        lowElementIndex:
          type: integer
          format: uint64
          minimum: 0
        merkleContext:
          $ref: '#/components/schemas/MerkleContext'
        path:
          type: array
          items:
            $ref: '#/components/schemas/Hash'
        root:
          $ref: '#/components/schemas/Hash'
        rootIndex:
          type: integer
          format: uint16
          description: '`root` のオンチェーン履歴上の位置です。'
          minimum: 0
        rootSeq:
          type: integer
          format: uint64
          description: |-
            ルートの順序キーです。状態ツリー証明の場合は完了済みの Solana スロット、
            インデックス付きツリー証明の場合はオンチェーン更新シーケンスです。
          minimum: 0
      additionalProperties: false
    MerkleContext:
      type: object
      required:
        - treeType
        - tree
      properties:
        tree:
          $ref: '#/components/schemas/SerializablePubkey'
        treeType:
          type: integer
          format: uint16
          minimum: 0
      additionalProperties: false
  securitySchemes:
    ApiKeyQuery:
      type: apiKey
      in: query
      name: api-key
      description: Helius API キーです。

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.